Index: imaps-backend/backendRender/.env
===================================================================
--- imaps-backend/backendRender/.env	(revision 79a03170cdde4e801d12257ee86723774970427b)
+++ imaps-backend/backendRender/.env	(revision 79a03170cdde4e801d12257ee86723774970427b)
@@ -0,0 +1,12 @@
+BACKEND_IP=192.168.104.7
+BACKEND_PORT=8080
+DB_PASS=Zim1M@jk41004
+DB_IP=192.168.104.7
+DB_PORT=5432
+DB_USER=stevetosak
+GITHUB_CLIENT_ID=Iv23liqzhX5wMYNDHtnz
+GITHUB_CLIENT_SECRET=6528f334f1731c8154c5fe872d222e188307b111
+GOOGLE_CLIENT_ID=1024418489231-ml40ukvqcg9ad1h5ejor5dm6ipt6p8fo.apps.googleusercontent.com
+GOOGLE_CLIENT_SECRET=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
+MAIL_NAME=stefantoska84@gmail.com
+MAIL_PASS=kqnj iyae ojrt beai
Index: imaps-backend/backendRender/.idea/.gitignore
===================================================================
--- imaps-backend/backendRender/.idea/.gitignore	(revision 79a03170cdde4e801d12257ee86723774970427b)
+++ imaps-backend/backendRender/.idea/.gitignore	(revision 79a03170cdde4e801d12257ee86723774970427b)
@@ -0,0 +1,8 @@
+# Default ignored files
+/shelf/
+/workspace.xml
+# Editor-based HTTP Client requests
+/httpRequests/
+# Datasource local storage ignored files
+/dataSources/
+/dataSources.local.xml
Index: imaps-backend/backendRender/Dockerfile
===================================================================
--- imaps-backend/backendRender/Dockerfile	(revision 79a03170cdde4e801d12257ee86723774970427b)
+++ imaps-backend/backendRender/Dockerfile	(revision 79a03170cdde4e801d12257ee86723774970427b)
@@ -0,0 +1,4 @@
+FROM openjdk:17-jdk-alpine
+ARG JAR_FILE=target/*.jar
+COPY ${JAR_FILE} app.jar
+ENTRYPOINT ["java","-jar","/app.jar"]
Index: imaps-backend/backendRender/run.sh
===================================================================
--- imaps-backend/backendRender/run.sh	(revision 79a03170cdde4e801d12257ee86723774970427b)
+++ imaps-backend/backendRender/run.sh	(revision 79a03170cdde4e801d12257ee86723774970427b)
@@ -0,0 +1,25 @@
+#!/bin/bash
+IMAGE_NAME="imaps-backend"
+TAG="latest"
+
+
+docker rm -f imaps-backendC
+
+if docker images "$IMAGE_NAME" | grep -q "$TAG"; then
+    echo "Image $IMAGE_NAME:$TAG found, deleting..."
+    docker rmi "$IMAGE_NAME:$TAG"
+else
+    echo "Image $IMAGE_NAME:$TAG not found."
+fi
+
+
+docker build -t imaps-backend .
+
+
+docker run \
+--name imaps-backendC \
+--privileged  \
+--env-file .env \
+-p 8080:8080 \
+-d \
+imaps-backend
Index: imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/BackendRenderApplication.java
===================================================================
--- imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/BackendRenderApplication.java	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
+++ imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/BackendRenderApplication.java	(revision 79a03170cdde4e801d12257ee86723774970427b)
@@ -3,4 +3,9 @@
 import org.springframework.boot.SpringApplication;
 import org.springframework.boot.autoconfigure.SpringBootApplication;
+import org.springframework.context.annotation.Bean;
+import org.springframework.mail.javamail.JavaMailSender;
+import org.springframework.mail.javamail.JavaMailSenderImpl;
+import org.springframework.security.crypto.bcrypt.BCryptPasswordEncoder;
+import org.springframework.security.crypto.password.PasswordEncoder;
 
 @SpringBootApplication
@@ -11,3 +16,8 @@
 	}
 
+	@Bean
+	public PasswordEncoder passwordEncoder(){
+		return new BCryptPasswordEncoder(12);
+	}
+
 }
Index: imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/config/OAuthConfig.java
===================================================================
--- imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/config/OAuthConfig.java	(revision 79a03170cdde4e801d12257ee86723774970427b)
+++ imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/config/OAuthConfig.java	(revision 79a03170cdde4e801d12257ee86723774970427b)
@@ -0,0 +1,29 @@
+package internettehnologii.imaps.backendRender.web.config;
+
+import lombok.Getter;
+import org.springframework.beans.factory.annotation.Value;
+import org.springframework.stereotype.Component;
+
+@Getter
+@Component
+public class OAuthConfig {
+    @Value("${github.client.id}")
+    private String GITHUB_CLIENT_ID;
+    @Value("${github.client.secret}")
+    private String GITHUB_CLIENT_SECRET;
+    @Value("${github.redirect.uri}")
+    private String GITHUB_REDIRECT_URI;
+    @Value("${google.redirect.uri}")
+    private String GOOGLE_REDIRECT_URI;
+    @Value("${google.client.id}")
+    private String GOOGLE_CLIENT_ID;
+    @Value("${google.client.secret}")
+    private String GOOGLE_CLIENT_SECRET;
+
+    private final String GITHUB_TOKEN_URL = "https://github.com/login/oauth/access_token";
+    private final String GITHUB_USER_URL = "https://api.github.com/user";
+
+    private final String GOOGLE_TOKEN_URL = "https://oauth2.googleapis.com/token";
+    private final String GOOGLE_USER_URL = "https://www.googleapis.com/oauth2/v3/userinfo";
+
+}
Index: imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/controllers/AdminController.java
===================================================================
--- imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/controllers/AdminController.java	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
+++ imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/controllers/AdminController.java	(revision 79a03170cdde4e801d12257ee86723774970427b)
@@ -4,6 +4,8 @@
 import internettehnologii.imaps.backendRender.web.service.interfaces.MapService;
 import internettehnologii.imaps.backendRender.web.service.interfaces.PublishRequestService;
+import internettehnologii.imaps.backendRender.web.service.interfaces.ReportService;
 import internettehnologii.imaps.backendRender.web.util.DTO.MapDTO;
 import internettehnologii.imaps.backendRender.web.util.DTO.PublishMapDTO;
+import internettehnologii.imaps.backendRender.web.util.DTO.ReportDTO;
 import internettehnologii.imaps.backendRender.web.util.Util;
 import org.springframework.http.ResponseEntity;
@@ -23,8 +25,10 @@
     private final MapService mapService;
     private final PublishRequestService publishRequestService;
+    private final ReportService reportService;
 
-    public AdminController(MapService mapService, PublishRequestService publishRequestService) {
+    public AdminController(MapService mapService, PublishRequestService publishRequestService, ReportService reportService) {
         this.mapService = mapService;
         this.publishRequestService = publishRequestService;
+        this.reportService = reportService;
     }
 
@@ -32,5 +36,5 @@
     public ResponseEntity<List<MapDTO>> getPendingMapRequests() {
         try {
-            List<MapDTO> maps = Util.convertToMapDTO(mapService.findByStatus(MAP_STATUS.INVALID));
+            List<MapDTO> maps = Util.convertToMapDTO(mapService.findByStatus(MAP_STATUS.PENDING));
             return ResponseEntity.ok(maps);
         } catch (Exception e) {
@@ -71,7 +75,7 @@
     }
     @PostMapping("/pr/deny")
-    public ResponseEntity<Map<String,Object>> denyPR(@RequestParam("id") Integer id) {
+    public ResponseEntity<Map<String,Object>> denyPR(@RequestParam("id") Integer id,@RequestParam String reason) {
         try{
-            publishRequestService.denyPublishRequest(id);
+            publishRequestService.denyPublishRequest(id,reason);
         } catch (Exception e){
             e.printStackTrace();
@@ -79,3 +83,23 @@
         return ResponseEntity.ok(new HashMap<>());
     }
+    @GetMapping("/load-reports")
+    public ResponseEntity<List<ReportDTO>> getReports() {
+        try {
+            List<ReportDTO> reportDTOS = reportService.getReports()
+                    .stream()
+                    .map(report ->
+                new ReportDTO(
+                        report.getUser().getUsername(),
+                        report.getMap().getName(),
+                        report.getSubject(),
+                        report.getContent(),
+                        report.getCreatedAt().toString()
+                        )
+            ).toList();
+            return ResponseEntity.ok(reportDTOS);
+        } catch (Exception e) {
+            e.printStackTrace();
+            return ResponseEntity.badRequest().build();
+        }
+    }
 }
Index: imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/controllers/AuthController.java
===================================================================
--- imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/controllers/AuthController.java	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
+++ imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/controllers/AuthController.java	(revision 79a03170cdde4e801d12257ee86723774970427b)
@@ -23,5 +23,5 @@
 @RequestMapping("/api/auth")
 @RestController
-@CrossOrigin(origins = "http://localhost:5173/")
+//@CrossOrigin(origins = "http://localhost:5173")
 public class AuthController {
 
Index: imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/controllers/InvalidStateException.java
===================================================================
--- imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/controllers/InvalidStateException.java	(revision 79a03170cdde4e801d12257ee86723774970427b)
+++ imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/controllers/InvalidStateException.java	(revision 79a03170cdde4e801d12257ee86723774970427b)
@@ -0,0 +1,7 @@
+package internettehnologii.imaps.backendRender.web.controllers;
+
+public class InvalidStateException extends RuntimeException {
+  public InvalidStateException(String message) {
+    super(message);
+  }
+}
Index: imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/controllers/MapDrawController.java
===================================================================
--- imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/controllers/MapDrawController.java	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
+++ imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/controllers/MapDrawController.java	(revision 79a03170cdde4e801d12257ee86723774970427b)
@@ -52,22 +52,23 @@
 
     @PostMapping("/publish/add")
-    public ResponseEntity<Map<String,Object>> sendPublishRequest(@RequestBody PublishMapDTO formData, @RequestParam String username) {
+    public ResponseEntity<MapDTO> sendPublishRequest(@RequestBody PublishMapDTO formData, @RequestParam String username) {
 
         System.out.println("FORM DATA: -------------------------------------------- " + formData);
-        try{
+        try {
             IMapsUser user = userService.getUser(username);
 
-            publishRequestService.addPublishRequest(formData,user);
-
-            return ResponseEntity.ok(new HashMap<>());
-
-        } catch (Exception e){
-            return ResponseEntity.status(HttpStatus.BAD_REQUEST).build();
-        }
-    }
+            MapDTO updatedMap = publishRequestService.addPublishRequest(formData, user);
+
+            return ResponseEntity.ok(updatedMap);
+
+        } catch (Exception e) {
+            return ResponseEntity.status(HttpStatus.BAD_REQUEST).build();
+        }
+    }
+
     @GetMapping("/publish/get")
     public ResponseEntity<PublishMapDTO> getPublishRequestForMap(@RequestParam String mapName) {
         PublishRequest pr = publishRequestService.getPublishRequestByMapName(mapName);
-        PublishMapDTO dto = new PublishMapDTO(pr.getId(),pr.getName(), pr.getLastName(), pr.getMap().getName(), pr.getMapType(), pr.getGMapsUrl());
+        PublishMapDTO dto = new PublishMapDTO(pr.getId(), pr.getName(), pr.getLastName(), pr.getMap().getName(), pr.getMapType(), pr.getGMapsUrl());
         return ResponseEntity.ok(dto);
     }
@@ -76,10 +77,10 @@
     public ResponseEntity<List<MapDTO>> getFavouriteMapsForUser(@RequestParam String username) {
 
-        try{
+        try {
             IMapsUser user = userService.getUser(username);
             List<MapDTO> mapDTOS = Util.convertToMapDTO(user.getFavoriteMaps());
             return ResponseEntity.ok().body(mapDTOS);
 
-        } catch (Exception e){
+        } catch (Exception e) {
             System.out.println(e.getMessage());
             return ResponseEntity.status(HttpStatus.BAD_REQUEST).build();
@@ -91,11 +92,6 @@
             (@RequestBody SaveMapDTO saveMapDTO, @RequestParam String username) {
 
-        System.out.println("MAP DTO: " + saveMapDTO);
-
-        try {
-
-            System.out.println("=================================");
-            System.out.println("MAPDTO: " + saveMapDTO);
-            System.out.println("USERNAME:" + username);
+
+        try {
             IndoorMap map = mapService.getMapForUser(username, saveMapDTO.getMapName());
             Floor f = floorService.getFloorByNum(saveMapDTO.getFloorNum(), map);
@@ -114,5 +110,5 @@
             System.out.println("UPDATED FLOOR " + f.getFloorNumber());
 
-            FloorDTO floorDTO = new FloorDTO(f.getFloorNumber(), saveMapDTO.getMapName(),f.getMapData().getShapeData());
+            FloorDTO floorDTO = new FloorDTO(f.getFloorNumber(), saveMapDTO.getMapName(), f.getMapData().getShapeData());
 
             return ResponseEntity.ok(floorDTO);
@@ -126,10 +122,10 @@
     @PutMapping("/my-maps/create")
     public ResponseEntity<MapDTO> createMap(@RequestBody CreateMapDTO mapData, @RequestParam String username) {
-        try{
-            mapService.createMap(mapData.getName(), mapData.getMapType() , username);
-            IndoorMap map = mapService.getMapForUser(username,mapData.getName());
+        try {
+            mapService.createMap(mapData.getName(), username);
+            IndoorMap map = mapService.getMapForUser(username, mapData.getName());
             MapDTO mapDTO = new MapDTO(map.getName(),
-                    map.getMapType()
-                    ,map.getCreatedAt(),
+                    map.getMapType(),
+                    map.getCreatedAt(),
                     map.getModifiedAt(),
                     map.getStatus().name(),
@@ -139,5 +135,4 @@
         } catch (Exception e) {
             System.out.println(e.getMessage());
-            e.printStackTrace();
             return ResponseEntity.status(HttpStatus.BAD_REQUEST).build();
         }
@@ -147,6 +142,6 @@
     @GetMapping("/my-maps/load")
     public ResponseEntity<List<FloorDTO>> loadPersonalMap(@RequestParam String mapName, @RequestParam String username) {
-        try{
-            IndoorMap map = mapService.getMapForUser(username,mapName);
+        try {
+            IndoorMap map = mapService.getMapForUser(username, mapName);
             List<Floor> floors = map.getFloors();
             return ResponseEntity.ok().body(Util.convertToFloorDTO(floors));
@@ -158,13 +153,13 @@
 
     @PostMapping("/room-types/add")
-    public ResponseEntity<Map<String,Object>> addRoomType(@RequestParam String roomTypeName,
-                                                          @RequestParam String username,
-                                                          @RequestParam String mapName) {
-        try {
-            IndoorMap map = mapService.getMapForUser(username,mapName);
-            roomTypeService.addRoomType(roomTypeName,map);
+    public ResponseEntity<Map<String, Object>> addRoomType(@RequestParam String roomTypeName,
+                                                           @RequestParam String username,
+                                                           @RequestParam String mapName) {
+        try {
+            IndoorMap map = mapService.getMapForUser(username, mapName);
+            roomTypeService.addRoomType(roomTypeName, map);
             return ResponseEntity.ok(new HashMap<>());
 
-        } catch (Exception e){
+        } catch (Exception e) {
             System.out.println(e.getMessage());
             return ResponseEntity.status(HttpStatus.BAD_REQUEST).build();
@@ -175,5 +170,5 @@
     public ResponseEntity<List<RoomTypeDTO>> getRoomTypesForMap(@RequestParam String mapName, @RequestParam String username) {
 
-        IndoorMap map = mapService.getMapForUser(username,mapName);
+        IndoorMap map = mapService.getMapForUser(username, mapName);
 
         List<RoomTypeDTO> roomTypeDTOS = map.getRoomTypes().stream().map(r -> new RoomTypeDTO(r.getName())).toList();
@@ -182,10 +177,10 @@
 
     @DeleteMapping("/floors/delete")
-    public ResponseEntity<Map<String,Object>> deleteFloor(@RequestParam String mapName,
-                                                          @RequestParam int floorNum) {
-        try{
-            floorService.deleteFloor(floorNum,mapName);
+    public ResponseEntity<Map<String, Object>> deleteFloor(@RequestParam String mapName,
+                                                           @RequestParam int floorNum) {
+        try {
+            floorService.deleteFloor(floorNum, mapName);
             return ResponseEntity.ok(new HashMap<>());
-        } catch (Exception e){
+        } catch (Exception e) {
             System.out.println(e.getMessage());
             return ResponseEntity.status(HttpStatus.BAD_REQUEST).build();
@@ -194,8 +189,8 @@
 
     @PutMapping("/floors/add")
-    public ResponseEntity<Map<String,Object>> addFloor(@RequestBody FloorDTO floorDTO) {
-        Map<String,Object> response = new HashMap<>();
-        try{
-            floorService.addFloor(floorDTO.getNum(),floorDTO.getMapName());
+    public ResponseEntity<Map<String, Object>> addFloor(@RequestBody FloorDTO floorDTO) {
+        Map<String, Object> response = new HashMap<>();
+        try {
+            floorService.addFloor(floorDTO.getNum(), floorDTO.getMapName());
             return ResponseEntity.ok(response);
         } catch (Exception e) {
@@ -226,4 +221,21 @@
 
 
+    @PostMapping("/my-maps/edit")
+    public ResponseEntity<MapDTO> updateMapInfo(@RequestBody EditMapDTO editMapDTO) {
+
+
+
+        try {
+
+            MapDTO mapDTO = mapService.updateMapInfo(editMapDTO);
+
+
+            return new ResponseEntity<>(mapDTO, HttpStatus.OK);
+
+        } catch (Exception e) {
+            return ResponseEntity.status(HttpStatus.BAD_REQUEST).build();
+        }
+
+    }
 
 
Index: imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/controllers/MapViewController.java
===================================================================
--- imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/controllers/MapViewController.java	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
+++ imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/controllers/MapViewController.java	(revision 79a03170cdde4e801d12257ee86723774970427b)
@@ -6,12 +6,10 @@
 import internettehnologii.imaps.backendRender.web.entities.IMapsUser;
 import internettehnologii.imaps.backendRender.web.entities.IndoorMap;
+import internettehnologii.imaps.backendRender.web.entities.Report;
 import internettehnologii.imaps.backendRender.web.exceptions.EmptyMapException;
-import internettehnologii.imaps.backendRender.web.exceptions.FloorNotFoundException;
-import internettehnologii.imaps.backendRender.web.service.interfaces.GraphService;
-import internettehnologii.imaps.backendRender.web.service.interfaces.FloorService;
-import internettehnologii.imaps.backendRender.web.service.interfaces.MapService;
-import internettehnologii.imaps.backendRender.web.service.interfaces.UserService;
+import internettehnologii.imaps.backendRender.web.service.interfaces.*;
 import internettehnologii.imaps.backendRender.web.util.DTO.FloorDTO;
 import internettehnologii.imaps.backendRender.web.util.DTO.MapDTO;
+import internettehnologii.imaps.backendRender.web.util.DTO.ReportDTO;
 import internettehnologii.imaps.backendRender.web.util.DTO.RoomTypeDTO;
 import internettehnologii.imaps.backendRender.web.util.Util;
@@ -34,11 +32,13 @@
     private final GraphService graphService;
     private final UserService userService;
+    private final ReportService reportService;
 
     @Autowired
-    public MapViewController(MapService mapService, FloorService floorService, GraphService graphService, UserService userService) {
+    public MapViewController(MapService mapService, FloorService floorService, GraphService graphService, UserService userService, ReportService reportService) {
         this.mapService = mapService;
         this.floorService = floorService;
         this.graphService = graphService;
         this.userService = userService;
+        this.reportService = reportService;
     }
 
@@ -120,5 +120,5 @@
             IndoorMap map = mapService.getMapByName(mapName);
             IMapsUser user = userService.getUser(username);
-            userService.addToFavorites(user, map);
+            userService.addFavoriteMap(user, map);
             return ResponseEntity.ok(new HashMap<>());
         } catch (Exception e){
@@ -132,5 +132,5 @@
             IndoorMap map = mapService.getMapByName(mapName);
             IMapsUser user = userService.getUser(username);
-            userService.removeFromFavorites(user, map);
+            userService.removeFavoriteMap(user, map);
             return ResponseEntity.ok(new HashMap<>());
         } catch (Exception e){
@@ -139,5 +139,20 @@
         }
     }
+    @PostMapping("/protected/reports/create")
+    public ResponseEntity<Map<String, Object>> createReport(
+            @RequestBody ReportDTO reportBody) {
+        try {
+            IMapsUser user = userService.getUser(reportBody.getUsername());
+            IndoorMap map = mapService.getMapByName(reportBody.getMapName());
+            Report report = new Report(user, map, reportBody.getSubject(), reportBody.getContent());
+            reportService.saveReport(report);
 
+            Map<String, Object> response = new HashMap<>();
+            return ResponseEntity.ok(response);
+        } catch (Exception e) {
+            e.printStackTrace();
+            return ResponseEntity.status(404).body(new HashMap<>());
+        }
+    }
 
 }
Index: imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/controllers/OAuthController.java
===================================================================
--- imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/controllers/OAuthController.java	(revision 79a03170cdde4e801d12257ee86723774970427b)
+++ imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/controllers/OAuthController.java	(revision 79a03170cdde4e801d12257ee86723774970427b)
@@ -0,0 +1,141 @@
+package internettehnologii.imaps.backendRender.web.controllers;
+
+import internettehnologii.imaps.backendRender.web.config.OAuthConfig;
+import internettehnologii.imaps.backendRender.web.service.interfaces.OAuthService;
+import internettehnologii.imaps.backendRender.web.service.interfaces.StateStore;
+import internettehnologii.imaps.backendRender.web.util.DTO.UserAuthSuccessDTO;
+import internettehnologii.imaps.backendRender.web.util.OAuthProviders;
+import org.springframework.beans.factory.annotation.Qualifier;
+import org.springframework.http.*;
+import org.springframework.stereotype.Controller;
+import org.springframework.web.bind.annotation.GetMapping;
+import org.springframework.web.bind.annotation.RequestMapping;
+import org.springframework.web.bind.annotation.RequestParam;
+import org.springframework.web.client.RestTemplate;
+
+import java.net.URI;
+import java.net.URLEncoder;
+import java.nio.charset.StandardCharsets;
+import java.util.*;
+
+@Controller
+@RequestMapping("/api/oauth")
+public class OAuthController {
+
+    private final StateStore stateStore;
+
+    private final OAuthService githubOAuthService;
+    private final OAuthService googleOAuthService;
+    private final OAuthConfig oAuthConfig;
+
+    private final RestTemplate restTemplate = new RestTemplate();
+
+    public OAuthController(StateStore stateStore,
+                           @Qualifier("githubOAuth") OAuthService githubOAuthService,
+                           @Qualifier("googleOAuth") OAuthService googleOAuthService,
+                           OAuthConfig oAuthConfig) {
+
+        this.stateStore = stateStore;
+        this.githubOAuthService = githubOAuthService;
+        this.googleOAuthService = googleOAuthService;
+        this.oAuthConfig = oAuthConfig;
+    }
+
+
+    @GetMapping("/state")
+    public ResponseEntity<String> getState() {
+        String uuid = UUID.randomUUID().toString();
+        stateStore.storeState(uuid);
+        return ResponseEntity.ok(uuid);
+    }
+
+
+    @GetMapping("/callback/github")
+    public ResponseEntity<UserAuthSuccessDTO> callbackGithub(@RequestParam("code") String code,
+                                                             @RequestParam("state") String state) {
+
+        if(!stateStore.isValidState(state))
+            throw new InvalidStateException("State is not valid: " + state);
+
+
+        String accessToken = exchangeCodeForAccessToken(code,OAuthProviders.GITHUB.name());
+        String userInfo = fetchUserInfo(accessToken,OAuthProviders.GITHUB.name());
+        System.out.println("User info: " + userInfo);
+        UserAuthSuccessDTO userAuthSuccessDTO = githubOAuthService.login(userInfo,accessToken);
+
+
+        String encodedUsrname = URLEncoder.encode(userAuthSuccessDTO.getUsername(), StandardCharsets.UTF_8);
+        String encodedToken = URLEncoder.encode(userAuthSuccessDTO.getToken(), StandardCharsets.UTF_8);
+
+        HttpHeaders headers = new HttpHeaders();
+        headers.setLocation(URI.create("https://imaps.mk/auth-callback?token=" + encodedToken + "&username=" + encodedUsrname));
+        headers.add("Set-Cookie", "Authorization=Bearer " + userAuthSuccessDTO + "; HttpOnly; Path=/; SameSite=Strict");
+
+        return new ResponseEntity<>(userAuthSuccessDTO,headers, HttpStatus.FOUND);
+    }
+    @GetMapping("/callback/google")
+    public ResponseEntity<UserAuthSuccessDTO> callbackGoogle(@RequestParam("code") String code,
+                                                             @RequestParam("state") String state){
+
+        if(!stateStore.isValidState(state))
+            throw new InvalidStateException("State is not valid: " + state);
+
+        String accessToken = exchangeCodeForAccessToken(code,OAuthProviders.GOOGLE.name());
+        String userInfo = fetchUserInfo(accessToken,OAuthProviders.GOOGLE.name());
+        UserAuthSuccessDTO userAuthSuccessDTO = googleOAuthService.login(userInfo,accessToken);
+
+        String encodedUsrname = URLEncoder.encode(userAuthSuccessDTO.getUsername(), StandardCharsets.UTF_8);
+        String encodedToken = URLEncoder.encode(userAuthSuccessDTO.getToken(), StandardCharsets.UTF_8);
+
+        HttpHeaders headers = new HttpHeaders();
+        headers.setLocation(URI.create("https://imaps.mk/auth-callback?token=" + encodedToken + "&username=" + encodedUsrname));
+        headers.add("Set-Cookie", "Authorization=Bearer " + userAuthSuccessDTO + "; HttpOnly; Path=/; SameSite=Strict");
+        return new ResponseEntity<>(userAuthSuccessDTO,headers, HttpStatus.FOUND);
+    }
+
+    Map<String,String> getBodyByProvider(String provider,String code) {
+        Map<String, String> body = new HashMap<>();
+        if(provider.equals(OAuthProviders.GOOGLE.name())){
+            body.put("client_id", oAuthConfig.getGOOGLE_CLIENT_ID());
+            body.put("client_secret", oAuthConfig.getGOOGLE_CLIENT_SECRET());
+            body.put("code", code);
+            body.put("redirect_uri", oAuthConfig.getGOOGLE_REDIRECT_URI());
+            body.put("grant_type", "authorization_code");
+        } else {
+            body.put("client_id", oAuthConfig.getGITHUB_CLIENT_ID());
+            body.put("client_secret", oAuthConfig.getGITHUB_CLIENT_SECRET());
+            body.put("code", code);
+            body.put("redirect_uri", oAuthConfig.getGITHUB_REDIRECT_URI());
+            body.put("scope","user");
+        }
+
+        return body;
+    }
+
+    private String exchangeCodeForAccessToken(String code,String provider) {
+        HttpHeaders headers = new HttpHeaders();
+        headers.setAccept(Collections.singletonList(MediaType.APPLICATION_JSON));
+
+        String url = Objects.equals(provider, OAuthProviders.GOOGLE.name()) ? oAuthConfig.getGOOGLE_TOKEN_URL() : oAuthConfig.getGITHUB_TOKEN_URL();
+
+        Map<String, String> body = getBodyByProvider(provider,code);
+        HttpEntity<Map<String,String>> request = new HttpEntity<>(body,headers);
+
+        ResponseEntity<Map> response = restTemplate.postForEntity(url, request, Map.class);
+        Map<String,Object> respBody = response.getBody();
+
+        return (String) respBody.get("access_token");
+    }
+
+    private String fetchUserInfo(String accessToken,String provider){
+        String url = Objects.equals(provider, OAuthProviders.GOOGLE.name()) ? oAuthConfig.getGOOGLE_USER_URL() : oAuthConfig.getGITHUB_USER_URL();
+
+        HttpHeaders headers = new HttpHeaders();
+        headers.setBearerAuth(accessToken);
+        HttpEntity<Void> request = new HttpEntity<>(headers);
+        ResponseEntity<String> response = restTemplate.exchange(url, HttpMethod.GET, request, String.class);
+
+        return response.getBody();
+    }
+
+}
Index: imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/entities/IMapsUser.java
===================================================================
--- imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/entities/IMapsUser.java	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
+++ imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/entities/IMapsUser.java	(revision 79a03170cdde4e801d12257ee86723774970427b)
@@ -30,4 +30,12 @@
     @Column(name = "profile_image_url")
     private String profileImageUrl;
+    @Column(name = "oauth_provider")
+    private String OAuthProvider;
+    @Column(name = "oauth_id")
+    private String oAuthId;
+    @Column(name = "access_token")
+    private String accessToken;
+    @Column(name = "refresh_token")
+    private String refreshToken;
 
     @ManyToMany
Index: imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/entities/IndoorMap.java
===================================================================
--- imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/entities/IndoorMap.java	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
+++ imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/entities/IndoorMap.java	(revision 79a03170cdde4e801d12257ee86723774970427b)
@@ -1,3 +1,4 @@
 package internettehnologii.imaps.backendRender.web.entities;
+import internettehnologii.imaps.backendRender.web.util.DTO.MapDTO;
 import jakarta.persistence.*;
 import lombok.Getter;
@@ -44,4 +45,5 @@
     private Boolean isPublished;
 
+
     @ManyToOne
     @JoinColumn(name = "usr_id",referencedColumnName = "id", nullable = false)
@@ -70,3 +72,14 @@
     }
 
+
+    public MapDTO toMapDTO(){
+        return  new MapDTO(getName(),
+                getMapType(),
+                getCreatedAt(),
+                getModifiedAt(),
+                getStatus().name(),
+                getFavouriteCount(),
+                getGmapsUrl());
+    }
+
 }
